package cz.muni.fi.pa165.ejb;

import javax.annotation.Resource;
import javax.ejb.Asynchronous;
import javax.ejb.EJB;
import javax.ejb.Local;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.interceptor.Interceptor;
import javax.interceptor.Interceptors;

@Stateless
@Local(value=CustomerServiceLocal.class)
//@Interceptors(LoggingInterceptor.class)
//@TransactionAttribute(TransactionAttributeType.REQUIRED)
public class CustomerService implements CustomerServiceLocal {

    @Resource
    private SessionContext ctx;
    
    @EJB
    private CustomerDaoLocal customerDao;

    @Override
    //@Asynchronous
    @Interceptors(LoggingInterceptor.class)
    public void createCustomer(Customer customer) {
        
        customerDao.createCustomer(customer);
 
        // Pokud bychom potrebovali vynutit rollback u CMT
        if (false) {
            ctx.setRollbackOnly();
        }
        
    }
    
}
